/*===============================================================
  ͨ·A*㷨Ż
  Common shortest path finding in A*

   ΰ 20011219
  Written by Wei Lin On Dec.19 2001

  ӿƼѧͨѶѧԺ20013080
  Uestc Dept.1 - 20013080
 */

#ifndef _ASTAR_H_
#define _ASTAR_H_

// #ifndefʼ#endifͷļ
typedef unsigned long ADWORD;
class AstarPathFind
{
protected:
	struct TAstarNode
	{
		ADWORD Pos;			// õ(16,16)ģʽ(y,x)
		short ActualCost;	// 㵽ýڵʵʿ
		short EstimateCost;	// ˵Ĺۿ
		TAstarNode *Father;	// ˵ĸڵ
		TAstarNode *Next;	// OpenNextеһڵ
		char Modified;		// ýڵǷ޸Ĺ¼1,2 Open,4 Close
	};

	TAstarNode **Node;		// Ӧͼÿڵ
	TAstarNode *Open;		// ûдİֵĽڵ
	TAstarNode *Close;		// 洦Ľڵ
	TAstarNode **Modify;	// ޸ĹĽڵ
	int height;				// ͼĸ߶
	int width;				// ͼĿ
	ADWORD MaxSize;			// height*width
	ADWORD ModifyPoint;		// Modifyָ
	ADWORD OpenCount;		// OpenеĽڵĿ
	ADWORD CloseCount;		// CloseĽڵĿ
	ADWORD OpenLimited;		// OpenڵĿ
	ADWORD CloseLimited;	// CloseڵĿ
	short DirMask;			// Ҫı־0-7λΪϿʼ˳ʱ߸
	ADWORD MinPos;			// յӽյĽڵ
	char (*MoveAble)(short x,short y);	// ͼǷƶָ
	short (*JudgeCost)(short x,short y);	// ȡùֵĺָ
	char AddToOpenQueue(TAstarNode *node);	// ڵOpen
	char GetFromOpenQueue();				// OpenȡСĲClose
	char PopCloseStack();					// ȡCloseеĽڵ
	void ClearModified();					// ¼
	char TryTile(short x,short y,TAstarNode *Father);
public:
	int Create(int map_w,int map_h,char (*MoveCheck)(short x,short y),short (*JudgeFun)(short x,short y));
	int Release();
	int FindPath(short startx,short starty,short endx,short endy);
	int GetPosPath(short *PosXY,int maxpos);
	int GetDirPath(char *Dirs,int maxpos);

	void SetJudgeFun(short (*JudgeFun)(short,short));
	void SetMapCheck(char (*MapCheck)(short,short));
	void SetOpenLimited(long OpenLimited);
	void SetCloseLimited(long CloseLimited);
	void SetDirMask(long DirMask);
};

#endif


#include <stdio.h>

#define COST_MAX 30000
#define tile_pos(x,y) (((ADWORD)y<<16)|x)
#define tile_x(pos)   (pos&0xffff)
#define tile_y(pos)   (pos>>16)

// ڵ, Ŀĵع۾
char AstarPathFind::AddToOpenQueue(TAstarNode *node)
{
	ADWORD i;
	short f=node->EstimateCost;
	TAstarNode *p,*b;
	node->Modified|=2;	// ¼Open־
	for (b=NULL,p=Open,i=0;p&&i<=OpenCount;b=p,p=p->Next,i++) 
		if (f<=p->EstimateCost) break;
	if (i>OpenCount) return -2;
	node->Next=p;
	if (b) b->Next=node;
	else Open=node;
	OpenCount++;
	return 0;
}
// Ŀĵعķ
char AstarPathFind::GetFromOpenQueue()
{
	TAstarNode *BestChoice=Open;
	if (!Open) return -1;
	Open=Open->Next;
	if (BestChoice->Modified&4) return -2; // ѾClose
	BestChoice->Next=Close;
	BestChoice->Modified&=5;	// Open־
	BestChoice->Modified|=4;	// Close־
	Close=BestChoice;
	OpenCount--;
	CloseCount++;
	return 0;
}
// ͷջڵ
char AstarPathFind::PopCloseStack()
{
	if (Close) { 
		Close->Modified&=3;		// Close־
		Close=Close->Next;
		CloseCount--; 
		return 0; 
	}
	return -1;
}
// ԭ޸Ĺнڵ
void AstarPathFind::ClearModified()
{
	ADWORD i;
	for (i=0;i<ModifyPoint;i++) {
		Modify[i]->Modified=0;
		Modify[i]->ActualCost=COST_MAX;
	}
	ModifyPoint=0;
	OpenCount=0;
	CloseCount=0;
	Open=NULL;
	Close=NULL;
}
// һƶ x,y з
char AstarPathFind::TryTile(short x,short y,TAstarNode *Father)
{
	int ActualCost;
	if (!MoveAble(x,y)) return 1;			// ͼ޷ͨ˳
	if (Node[y][x].Modified&6) return 1;	// ѾOpen,Close˳
	ActualCost=Father->ActualCost+1;		// ʵֵ
	if (ActualCost>=Node[y][x].ActualCost) return 1;
	if (!Node[y][x].Modified) Modify[ModifyPoint++]=&Node[y][x]; // ¼޸ĹĵԻԭ
	Node[y][x].ActualCost=ActualCost;
	Node[y][x].Modified=1;
	Node[y][x].Father=Father;
	Node[y][x].EstimateCost=ActualCost+JudgeCost(x,y);
	AddToOpenQueue(&Node[y][x]);			// ڵOpen
	return 0;
}
// ·Ѱ
int AstarPathFind::FindPath(short startx,short starty,short endx,short endy)
{
	TAstarNode *root;
	int i,j,x,y,ok,dirs,max=0;
	short MinJudge;
	static short incx[8]={ 0, 1, 1, 1, 0, -1, -1, -1 };
	static short incy[8]={ -1, -1, 0, 1, 1, 1, 0, -1 };

	if (!Node||!Modify) return -1;
	ClearModified();
	root=&Node[starty][startx];
	root->ActualCost=0;
	root->EstimateCost=JudgeCost(startx,starty);
	root->Father=NULL; 
	root->Modified=1;
	Modify[ModifyPoint++]=root;
	AddToOpenQueue(root);
	MinPos=tile_pos(startx,starty);
	MinJudge=JudgeCost(startx,starty);
	for (ok=0;ok==0;)
	{
		ok=GetFromOpenQueue();		// ȡOpenйֵСĽڵClose
		root=Close;					// õղȡĽڵ
		if (ok||root==NULL) { ok=-1; break; }
		x=tile_x(root->Pos);
		y=tile_y(root->Pos);
		if (root->EstimateCost-root->ActualCost<MinJudge)	// ҵһյĵ
			MinJudge=root->EstimateCost-root->ActualCost, MinPos=root->Pos;
		if (CloseCount>max) max=CloseCount;
		if (x==endx&&y==endy) MinPos=root->Pos,ok=1;	// ߵյ
		else {
			for (i=0,dirs=1,j=1;i<8;i++,dirs<<=1)		// ûߵյ
				if (DirMask&dirs) j&=TryTile(x+incx[i],y+incy[i],root);
			if (j) if (PopCloseStack()) { ok=-2; break; }	// ͨ·Closeȡ
		}
		if (OpenCount>=OpenLimited||CloseCount>=CloseLimited) ok=2;
	}
	if (ok<0) return -2;
	return 0;
}
int AstarPathFind::GetPosPath(short *PosXY,int maxpos)
{
	short x,y;
	ADWORD Pos,j;
	TAstarNode *p,*s;
	int i;
	if (maxpos>1) maxpos--;
	for (p=&Node[tile_y(MinPos)][tile_x(MinPos)],s=p,j=0;p&&j<MaxSize;p=p->Father,j++)
	{
		x=tile_x(p->Pos);
		y=tile_y(p->Pos);
		i=(p->ActualCost<maxpos)?p->ActualCost:maxpos;
		PosXY[i<<1]=x;
		PosXY[(i<<1)+1]=y;
	}
	i=(s->ActualCost+1<maxpos)?(s->ActualCost+1):maxpos;
	PosXY[i*2]=-1;
	PosXY[i*2+1]=-1;
	return 0;
}
int AstarPathFind::GetDirPath(char *PosDir,int maxpos)
{
	static short incx[8]={ 0, 1, 1, 1, 0, -1, -1, -1 };
	static short incy[8]={ -1, -1, 0, 1, 1, 1, 0, -1 };
	static char inc2r[10]={ 0,0,0,0 };
	short i,x,y,nx,ny;
	ADWORD j;
	TAstarNode *p,*s;
	if (!inc2r[0])
	{
		for (i=0;i<8;i++) inc2r[(incy[i]+1)*3+incx[i]+1]=i;
		inc2r[4]=8;
	}
	x=tile_x(MinPos);
	y=tile_y(MinPos);
	if (maxpos>1) maxpos--;
	for (p=&Node[y][x],s=p,j=0;p&&j<MaxSize;p=p->Father,j++)
	{
		nx=tile_x(p->Pos);
		ny=tile_y(p->Pos);
		i=(p->ActualCost<maxpos)?(p->ActualCost):maxpos;
		PosDir[i]=inc2r[(y-ny+1)*3+x-nx+1];
		x=nx;
		y=ny;
	}
	i=(s->ActualCost+1<maxpos)?(s->ActualCost+1):maxpos;
	PosDir[i]=8;
	return 0;
}
int AstarPathFind::Create(int mapw,int maph,char (*MoveCheck)(short,short),short (*JudgeFun)(short x,short y))
{
	int i,j;

	height=maph;	width=mapw;
	MaxSize=maph;	MaxSize*=mapw;
	Modify=new TAstarNode*[MaxSize];
	if (!Modify) return -1;
	Node=new TAstarNode*[maph];
	if (!Node) { delete Modify; Modify=NULL; return -1; }
	for (i=0;i<maph;i++) Node[i]=new TAstarNode[mapw];
	for (i=0,j=1;i<maph;i++) if (!Node[i]) j=0;
	if (!j)
	{
		for (i=0;i<maph;i++) if (Node[i]) delete Node[i];
		delete Node;
		delete Modify;
		Node=NULL;
		Modify=NULL;
		return -2;
	}
	for (j=0;j<maph;j++) 
		for (i=0;i<mapw;i++) 
		{
			Node[j][i].Pos=tile_pos(i,j);
			Node[j][i].Modified=0;
			Node[j][i].ActualCost=COST_MAX;
		}
	ModifyPoint=0;
	SetMapCheck(MoveCheck);
	SetJudgeFun(JudgeFun);
	SetDirMask(0x55);
	SetOpenLimited(200);
	SetCloseLimited(MaxSize/20);
	return 0;
}
int AstarPathFind::Release()
{
	int i,j;
	if (Node) for (j=0;j<height;j++) if (Node[j]) delete Node[j];
	if (Node) delete Node;
	if (Modify) delete Modify;
	Node=NULL;
	Modify=NULL;
	return 0;
}
void AstarPathFind::SetJudgeFun(short (*JudgeFun)(short,short)) { JudgeCost=JudgeFun; }
void AstarPathFind::SetMapCheck(char (*MapCheck)(short,short)) { MoveAble=MapCheck; }
void AstarPathFind::SetOpenLimited(long OL) { OpenLimited=OL; }
void AstarPathFind::SetCloseLimited(long CL) { CloseLimited=CL; }
void AstarPathFind::SetDirMask(long DM) { DirMask=DM; }
